<template>
  <section class="section">
    <div class="container">
      <h1 class="title">Create Form</h1>
      <hr>
      <div v-if="$apollo.loading">Loading...</div>
      <b-field v-if="!$apollo.loading" label="Find a project">
        <b-autocomplete
          v-model="project"
          placeholder="e.g. My Repo"
          :loading="$apollo.loading"
          :keep-first="true"
          :open-on-focus="true"
          :data="filteredDataObj"
          field="name"
          @select="selectProject">
        </b-autocomplete>
      </b-field>
      <br>
      <div v-if="selected"  class="column is-half">
        <b-field label="Name">
          <b-input v-model="form.name" placeholder="Form Name" required />
        </b-field>
        <div class="field">
          <label class="label">Message</label>
          <p class="help is-success">This is used to describe the form in your dashboard, it will not be shown publicly.</p>
          <div class="control">
            <textarea v-model="form.description" class="textarea" placeholder="Optional, but useful" maxlength="500" type="textarea"></textarea>
          </div>
        </div>
        <br>
        <button class="button is-success is-outlined" @click="createForm">Create Form</button>
      </div>
    </div>
  </section>
</template>

<script>
import GET_USER_PROJECTS from '@/graphql/User/Projects/UserProjects.gql'
import CREATE_FORM_MUTATION from '@/graphql/Form/CreateForm.gql'
import ALL_FORMS_QUERY from '@/graphql/Form/AllForms.gql'
export default {
  data: () => ({
    project: '',
    selected: null,
    form: {}
  }),
  apollo: {
    allProjects: {
      query: GET_USER_PROJECTS
    }
  },
  computed: {
    filteredDataObj () {
      return this.allProjects.filter((option) => {
        return option.name
          .toString()
          .toLowerCase()
          .indexOf(this.project.toLowerCase()) >= 0
      })
    }
  },
  methods: {
    selectProject (project) {
      if (project) {
        this.selected = project
        this.form.name = project.name
      } else {
        this.selected = null
        this.form = {}
      }
    },
    createForm () {
      this.$apollo.mutate({
        mutation: CREATE_FORM_MUTATION,
        variables: {
          projectId: this.selected.id,
          name: this.form.name,
          description: this.form.description
        },
        // Update the cache with the result
        // The query will be updated with the optimistic response
        // and then with the real result of the mutation
        update: (store, { data: { createForm: newForm } }) => {
          // Read the data from our cache for this query.
          const data = store.readQuery({ query: ALL_FORMS_QUERY })
          // Add our tag from the mutation to the end
          data.allForms.push(newForm)
          // Write our data back to the cache.
          store.writeQuery({ query: ALL_FORMS_QUERY, data })
        }
      }).then(({ data: { createForm } }) => {
        this.$dialog.alert({
          title: 'Great!',
          message: 'Cool, you have created a form! Visit it below.',
          confirmText: 'Visit',
          onConfirm: () => {
            this.$router.push(`/form/${createForm.id}`)
          }
        })
      }).catch(err => console.error(err))
    }
  }
}
</script>
